
package com.locad.geometry;

import com.locad.enumerations.Enumerations.RenderMaterialTypes;
import com.locad.enumerations.Enumerations.ShapeTypes;
import com.locad.ldraw.ColorLibrary;
import javax.media.opengl.GL;

public class LineConditional extends Shape
{
    public Point3f p1 = null;
    public Point3f p2 = null;
    public Point3f p3 = null;
    public Point3f p4 = null;

    public Point3f s1 = null;
    public Point3f s2 = null;
    public Point3f s3 = null;
    public Point3f s4 = null;

    public LineConditional()
    {
        super(ShapeTypes.LINE);
    }

    public static LineConditional from_Line (String input)
    {
        LineConditional line = new LineConditional();

        String[] tokens = input.trim().split(" ");
        String[] t = new String[tokens.length];
        int ndx = 0;
        for (int i=0; i<tokens.length; i++)
        {
            if (tokens[i] == null ? "" != null : ! tokens[i].equals(""))
            {
                t[ndx] = tokens[i];
                ndx++;
            }
        }

        line.colorCode = new Integer(t[1]);
        line.p1 = new Point3f(new Float(t[2]), new Float(t[3]), new Float(t[4]));
        line.p2 = new Point3f(new Float(t[5]), new Float(t[6]), new Float(t[7]));
        line.p3 = new Point3f(new Float(t[8]), new Float(t[9]), new Float(t[10]));
        line.p4 = new Point3f(new Float(t[11]), new Float(t[12]), new Float(t[13]));

        return line;
    }

    @Override
    public void addToGL(GL gl, Matrix4f orientation, int requestedColorCode, RenderMaterialTypes renderMaterialType, ColorLibrary colorLib, boolean BFCflag)
    {
//        Color color = getColor(requestedColorCode, renderMaterialType, colorLib);
//        if (color != null)
//        {
//            colorLib.getColor(requestedColorCode).material.ApplyToGL(gl);
//
//            s1 = new Point3D(screenX(p1.x, p1.y, p1.z), screenY(p1.x, p1.y, p1.z), 0.0);
//            s2 = new Point3D(screenX(p2.x, p2.y, p2.z), screenY(p2.y, p2.y, p2.z), 0.0);
//            s3 = new Point3D(screenX(p3.x, p3.y, p3.z), screenY(p3.y, p3.y, p3.z), 0.0);
//            s4 = new Point3D(screenX(p4.x, p4.y, p4.z), screenY(p4.y, p4.y, p4.z), 0.0);
//
//            float r1 = (s1.x - s2.x) * (s3.y - s1.y) - (s1.y - s2.y) * (s3.x - s1.x);
//            float r2 = (s1.x - s2.x) * (s4.y - s1.y) - (s1.y - s2.y) * (s4.x - s1.x);
//            if (r1 <= 0 == r2 <= 0)
//            {
//                gl.glBegin(GL.GL_LINES);
//                gl.glColor4f(color.getRed() / 255f, color.getGreen() / 255f, color.getBlue() / 255f, color.getAlpha() / 255f);
//                gl.glVertex3f(origin.x + p1.x, origin.y + p1.y, origin.z + p1.z);
//                gl.glVertex3f(origin.x + p2.x, origin.y + p2.y, origin.z + p2.z);
//                gl.glEnd();
//            }
//        }
    }

    @Override
    public Point3f getFurthestPointFromOrigin ()
    {
        Point3f tmp = p1;
        if (p2.mag() > tmp.mag())
            tmp = p2;

        return tmp;
    }

    @Override
    public String toString ()
    {
        StringBuilder strBuffer = new StringBuilder();

        strBuffer.append(super.toString()).append("\n");
        strBuffer.append("p1 ").append(p1).append("\n");
        strBuffer.append("p2 ").append(p2).append("\n");

        return strBuffer.toString();
    }
}
