
package com.locad.geometry;

import com.locad.enumerations.Enumerations.RenderMaterialTypes;
import com.locad.enumerations.Enumerations.ShapeTypes;
import com.locad.ldraw.ColorLibrary;
import com.locad.ldraw.LDrawColor;
import java.awt.Color;
import javax.media.opengl.GL;

public class Shape
{
    public int colorCode;
    public final ShapeTypes shapeType;

    public Shape (ShapeTypes shapeType)
    {
        this.shapeType = shapeType;
    }

    public void addToGL(GL gl, Matrix4f orientation, int requestedColorCode, RenderMaterialTypes renderMaterialType, ColorLibrary colorLib, boolean BFCflag)
    {
    }

    public Point3f getFurthestPointFromOrigin ()
    {
        return new Point3f(0f, 0f, 0f);
    }

    protected Color getColor(int requestedColorCode, RenderMaterialTypes renderMaterialType, ColorLibrary colorLib)
    {
        LDrawColor material = colorLib.getColor(colorCode);
        if (colorCode == 16 || colorCode == 24)
            material = colorLib.getColor(requestedColorCode);

        if (material.renderMaterialType == renderMaterialType)
        {
            if (colorCode == 24)
                return material.edgeColor;

            return material.fillColor;
        }

        return null;
    }

    @Override
    public String toString ()
    {
        StringBuilder strBuffer = new StringBuilder();

        strBuffer.append("colorCode ").append(colorCode).append("\n");
        strBuffer.append("shapeType ").append(shapeType).append("\n");

        return strBuffer.toString();
    }
}
