
package com.locad.ldraw;

import com.locad.enumerations.Enumerations.ShapeTypes;
import com.locad.geometry.Matrix4f;
import com.locad.geometry.Point3f;
import com.locad.geometry.Shape;

public class PartEmbeded extends Shape
{
    public String fileName;

    public Point3f origin;
    public Matrix4f orientation;
    public boolean BFCflag;

    public PartEmbeded ()
    {
        super(ShapeTypes.PART);
    }

    public static PartEmbeded from_Line (String input, boolean BFCflag)
    {
        PartEmbeded part = new PartEmbeded();

        part.BFCflag = BFCflag;

        String[] tokens = input.trim().split(" ");
        String[] t = new String[tokens.length];
        int ndx = 0;
        for (int i=0; i<tokens.length; i++)
        {
            if (tokens[i] == null ? "" != null : ! tokens[i].equals(""))
            {
                t[ndx] = tokens[i];
                ndx++;
            }
        }

        part.colorCode = new Integer(t[1]);
        part.origin = new Point3f(new Float(t[2]), new Float(t[3]), new Float(t[4]));
        part.orientation = new Matrix4f(new Float(t[5]), new Float(t[8]), new Float(t[11]), 0f,
                                              new Float(t[6]), new Float(t[9]), new Float(t[12]), 0f,
                                              new Float(t[7]), new Float(t[10]), new Float(t[13]), 0f,
                                              new Float(t[2]), new Float(t[3]), new Float(t[4]), 1f);
        part.fileName = t[14].replace("\\", "/").toUpperCase();

        return part;
    }

    @Override
    public String toString ()
    {
        StringBuilder strBuffer = new StringBuilder();

        strBuffer.append("fileName ").append(fileName).append("\n");
        strBuffer.append("origin ").append(origin.toString()).append("\n");
        //strBuffer.append("orientation ").append(orientation.toString()).append("\n");

        return strBuffer.toString();
    }
}

