
package com.locad.viewport;

import com.locad.geometry.Vec4f;
import javax.media.opengl.GL;

public class Light
{
    public float[] ambient = {0f, 0f, 0f, 0f};
    public float[] diffuse = {0f, 0f, 0f, 0f};
    public float[] specular = {0f, 0f, 0f, 0f};
    public Vec4f pos = new Vec4f(0f, 0f, 0f, 0f);

    public Light(float[] ambient, float[] diffuse, float[] specular, Vec4f pos)
    {
        this.ambient = ambient;
        this.diffuse = diffuse;
        this.specular = specular;
        this.pos = pos;
    }

    public void ApplyToGL(GL gl, int lightNum)
    {
        gl.glLightfv(lightNum, GL.GL_AMBIENT, ambient, 0);
        gl.glLightfv(lightNum, GL.GL_DIFFUSE, diffuse, 0);
        gl.glLightfv(lightNum, GL.GL_SPECULAR, specular, 0 );
        gl.glLightfv(lightNum, GL.GL_POSITION, pos.toArray(), 0);
        gl.glEnable(lightNum);
    }

    @Override
    public String toString ()
    {
        StringBuilder strBuffer = new StringBuilder();

        strBuffer.append("ambient ").append(ambient).append("\n");
        strBuffer.append("diffuse ").append(diffuse).append("\n");
        strBuffer.append("specular ").append(specular).append("\n");
        strBuffer.append("pos ").append(pos).append("\n");

        return strBuffer.toString();
    }
}
