
package com.locad.viewport;

import javax.media.opengl.GL;

public class Material
{
    public float[] ambient = {0.0f, 0.0f, 0.0f, 1.0f};
    public float[] diffuse = {0.0f, 0.0f, 0.0f, 1.0f};
    public float[] specular = {0.0f, 0.0f, 0.0f, 1.0f};
    public float shininess = 0.0f;

    public Material(float[] ambient, float[] diffuse, float[] specular, float shininess)
    {
        this.ambient = ambient;
        this.diffuse = diffuse;
        this.specular = specular;
        this.shininess = shininess;
    }

    public void ApplyToGL(GL gl)
    {
        gl.glMaterialfv(GL.GL_FRONT, GL.GL_AMBIENT, ambient, 0);
        gl.glMaterialfv(GL.GL_FRONT, GL.GL_DIFFUSE, diffuse, 0);
        gl.glMaterialfv(GL.GL_FRONT, GL.GL_SPECULAR, specular, 0);
        gl.glMaterialf(GL.GL_FRONT, GL.GL_SHININESS, shininess);
    }

    @Override
    public String toString ()
    {
        StringBuilder strBuffer = new StringBuilder();

        strBuffer.append("ambient ").append(ambient).append("\n");
        strBuffer.append("diffuse ").append(diffuse).append("\n");
        strBuffer.append("specular ").append(specular).append("\n");
        strBuffer.append("shininess ").append(shininess).append("\n");

        return strBuffer.toString();
    }
}
