
package com.locad.enumerations;

public class Enumerations
{
    public enum BFCTypes { NONE, CW, CCW };

    public enum MaterialTypes { LUMINANT, RUBBER, PLASTIC, GLITTER, SPECKLE, METAL, PEARLESCENT, CHROME, TRANSPARENT};

    public enum ViewAngleModes { TOP, BOTTOM, FRONT, BACK, LEFT, RIGHT, ISOMETRIC, PARTS_BAG }

    public enum ShapeTypes { UNKNOWN, LINE, TRIANGLE, QUADRILATERAL, PART };

    public enum CategoryTypes
    {
        OFFICIAL_MODEL, UNOFFICIAL_MODEL, OFFICIAL_PART, UNOFFICIAL_PART, OFFICIAL_SUBPART, UNOFFICIAL_SUBPART, OFFICIAL_PRIMITIVE, UNOFFICIAL_PRIMITIVE, OFFICIAL_48_PRIMITIVE, UNOFFICIAL_48_PRIMITIVE, UNDEFINED;

        public static String toString (CategoryTypes category)
        {
            if (category == OFFICIAL_MODEL)
                return "Model";
            else if (category == UNOFFICIAL_MODEL)
                return "Unofficial_Model";
            else if (category == OFFICIAL_PART)
                return "Part";
            else if (category == UNOFFICIAL_PART)
                return "Unofficial_Part";
            else if (category == OFFICIAL_SUBPART)
                return "Subpart";
            else if (category == UNOFFICIAL_SUBPART)
                return "Unofficial_Subpart";
            else if (category == OFFICIAL_PRIMITIVE)
                return "Primitive";
            else if (category == UNOFFICIAL_PRIMITIVE)
                return "Unofficial_Primitive";
            else if (category == OFFICIAL_48_PRIMITIVE)
                return "48_Primitive";
            else if (category == UNOFFICIAL_48_PRIMITIVE)
                return "Unofficial_48_Primitive";
            else
                return "Undefined Category Type";
        }

        public static CategoryTypes fromString (String category)
        {
            category.toLowerCase();
            if (category.contains("unofficial"))
            {
                if (category.contains("primitive"))
                {
                    if (category.contains("48") || category.contains("_48_"))
                        return UNOFFICIAL_48_PRIMITIVE;
                    else
                        return UNOFFICIAL_PRIMITIVE;
                }
                else if (category.contains("subpart"))
                    return UNOFFICIAL_SUBPART;
                else if (category.contains("part"))
                    return UNOFFICIAL_PART;
                else if (category.contains("model"))
                    return UNOFFICIAL_MODEL;
                else
                    return UNDEFINED;
            }
            else
            {
                if (category.contains("primitive"))
                {
                    if (category.contains(" 48 ") || category.contains("_48_"))
                        return OFFICIAL_48_PRIMITIVE;
                    else
                        return OFFICIAL_PRIMITIVE;
                }
                else if (category.contains("subpart"))
                    return OFFICIAL_SUBPART;
                else if (category.contains("part"))
                    return OFFICIAL_PART;
                else if (category.contains("model"))
                    return OFFICIAL_MODEL;
                else
                    return UNDEFINED;
            }
        }
    }

    public enum LicenseTypes
    {
        CCAL2, UNKNOWN, UNDEFINED;

        public static String toString (LicenseTypes license)
        {
            if (license == CCAL2)
                return "Redistributable under CCAL version 2.0 : see CAreadme.txt";
            else if (license == UNKNOWN)
                return "Unknown License Type";
            else
                return "Undefined License Type";
        }

        public static LicenseTypes fromString (String license)
        {
            if (license.contains("CCAL") && license.contains("2.0"))
                return CCAL2;
            else if (license.contains("Unknown") || license.contains("unknown") || license.contains("UNKNOWN"))
                return UNKNOWN;
            else
                return UNDEFINED;
        }
    }
}
