
package com.locad.geometry;

import com.locad.enumerations.Enumerations.MaterialTypes;
import com.locad.enumerations.Enumerations.ShapeTypes;
import com.locad.enumerations.Enumerations.ViewAngleModes;
import com.locad.ldraw.ColorLibrary;
import com.locad.ldraw.LDrawColor;
import java.awt.Color;
import java.util.ArrayList;
import java.util.Map;
import javax.media.opengl.GL;

public class Shape
{
    public Color color = new Color(0f, 0f, 0f);
    public int colorCode = 0;
    public LDrawColor material = null;
    public ShapeTypes shapeType;

    public Point3f minPoint = new Point3f(Float.MAX_VALUE, Float.MAX_VALUE, Float.MAX_VALUE);
    public Point3f maxPoint = new Point3f(-Float.MAX_VALUE, -Float.MAX_VALUE, -Float.MAX_VALUE);
    public Point3f centroid = new Point3f(0, 0, 0);

    public Shape ()
    {
    }

    public Shape (ShapeTypes shapeType)
    {
        this.shapeType = shapeType;
    }

    public void addToGL(GL gl)
    {
    }

    public void addToGLwithBFC(GL gl)
    {
    }

    public void addToList(Map<MaterialTypes, ArrayList<Shape>> materials, int requestedColorCode, float lineWidth)
    {
    }

    public void addToListBFC(Map<MaterialTypes, ArrayList<Shape>> materials, int requestedColorCode, float lineWidth, boolean BFCflag)
    {
    }

    public void setOrientation(Matrix4f orientation)
    {
    }

    public void setColor(int requestedColorCode, int currentColorCode)
    {
        if (currentColorCode == 16 || currentColorCode == 24)
        {
            colorCode = requestedColorCode;
            material = ColorLibrary.getInstance().getColor(requestedColorCode);
        }
        else
        {
            colorCode = currentColorCode;
            material = ColorLibrary.getInstance().getColor(currentColorCode);
        }

        if (currentColorCode == 24)
        {
            color = material.edgeColor;
        }
        else
        {
            color = material.fillColor;
        }
    }

    public Point3f getCentroid (Point3f minPoint, Point3f maxPoint)
    {
        return new Point3f(0f, 0f, 0f);
    }

    public boolean contains (float x, float y, ViewAngleModes viewAngle)
    {
        return false;
    }

    public Shape copy()
    {
        Shape that = new Shape();
        that.shapeType = this.shapeType;
        that.colorCode = this.colorCode;
        that.color = this.color;
        if (this.material != null)
            that.material = this.material.copy();
        that.centroid = this.centroid.copy();
        that.minPoint = this.minPoint.copy();
        that.maxPoint = this.maxPoint.copy();
        return that;
    }

    @Override
    public String toString ()
    {
        StringBuilder strBuffer = new StringBuilder();

        strBuffer.append("colorCode ").append(colorCode).append("\n");
        strBuffer.append("shapeType ").append(shapeType).append("\n");

        return strBuffer.toString();
    }
}
