
package com.locad.ldraw;

import com.locad.enumerations.Enumerations.MaterialTypes;
import java.awt.Color;
import java.util.ArrayList;
import java.util.List;

public class LDrawColor
{
    public final String name;
    public final Color fillColor;
    public final Color edgeColor;
    public final int luminance;
    public List<MaterialTypes> materialTypes = new ArrayList<MaterialTypes>();

    public LDrawColor (String name, Color fillColor, Color edgeColor, int luminance, List<MaterialTypes> materialTypes)
    {
        this.name = name.toUpperCase();
        this.fillColor = fillColor;
        this.edgeColor = edgeColor;
        this.luminance = luminance;
        this.materialTypes = materialTypes;
    }

    public LDrawColor copy()
    {
        return new LDrawColor(this.name, this.fillColor, this.edgeColor, this.luminance, this.materialTypes);
    }

    @Override
    public String toString ()
    {
        StringBuilder strBuffer = new StringBuilder();

        strBuffer.append(" name: ").append(name).append(" fillColor: ").append(fillColor).append(" edgeColor: ").append(edgeColor).append(" luminance: ").append(luminance).append("\n");

        return strBuffer.toString();
    }
}