
package com.locad.ldraw;

import com.locad.geometry.Matrix4f;

public class PartEmbeded
{
    public String fileName;

    public Matrix4f orientation;
    public int colorCode;
    public boolean BFCflag;

    public PartEmbeded ()
    {
    }

    public static PartEmbeded from_Line (String input, Matrix4f orientation, boolean BFCflag)
    {
        PartEmbeded part = new PartEmbeded();

        part.BFCflag = BFCflag;

        String[] tokens = input.trim().split(" ");
        String[] t = new String[tokens.length];
        int ndx = 0;
        for (int i=0; i<tokens.length; i++)
        {
            if (tokens[i] == null ? "" != null : ! tokens[i].equals(""))
            {
                t[ndx] = tokens[i];
                ndx++;
            }
        }

        part.colorCode = new Integer(t[1]);
        part.orientation = new Matrix4f(new Float(t[5]), new Float(t[8]), new Float(t[11]), 0f,
                                              new Float(t[6]), new Float(t[9]), new Float(t[12]), 0f,
                                              new Float(t[7]), new Float(t[10]), new Float(t[13]), 0f,
                                              new Float(t[2]), new Float(t[3]), new Float(t[4]), 1f);

        // apply orientation from parent
        part.orientation = part.orientation.times(orientation);

        if (part.orientation.isInverting())
            part.BFCflag = !part.BFCflag;

        part.fileName = t[14].replace("\\", "/").toUpperCase();

        return part;
    }

    public PartEmbeded copy()
    {
        PartEmbeded that = new PartEmbeded();

        that.fileName = this.fileName;
        that.orientation = this.orientation.copy();
        that.colorCode = this.colorCode;
        that.BFCflag = this.BFCflag;
        return that;
    }

    @Override
    public String toString ()
    {
        StringBuilder strBuffer = new StringBuilder();
        strBuffer.append("fileName ").append(fileName).append("\n");
        strBuffer.append(super.toString());
        strBuffer.append("BFCflag ").append(BFCflag).append("\n");
        strBuffer.append("orientation ").append(orientation.toString()).append("\n");
        return strBuffer.toString();
    }
}

