
package com.locad.viewport;

import com.locad.enumerations.Enumerations.ViewAngleModes;
import com.sun.opengl.util.FPSAnimator;
import java.awt.Color;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import javax.media.opengl.GLCapabilities;
import javax.media.opengl.GLJPanel;

public class Canvas extends GLJPanel
{
    public ViewAngleModes viewAngle;

    public FPSAnimator animator;

    public Canvas (ViewAngleModes viewAngle, Scene scene, Color bgColor)
    {
        super(createGLCapabilites());
        
        this.viewAngle = viewAngle;
        this.animator = new FPSAnimator(this, 30);
        this.addGLEventListener(new Renderer(viewAngle, scene, bgColor));

        this.addMouseListener(new mouseListener(scene));
    }

    public class mouseListener implements MouseListener
    {
        private final Scene scene;

        public mouseListener(Scene scene)
        {
            this.scene = scene;
        }

        public void mouseClicked(MouseEvent e)
        {
        }
        public void mousePressed(MouseEvent e)
        {
        }
        public void mouseReleased(MouseEvent e)
        {
        }
        public void mouseEntered(MouseEvent e)
        {
            if (viewAngle == ViewAngleModes.PARTS_BAG)
                setToolTipText(scene.getPart().getName());

            new Thread(new Runnable()
            {
                @Override
                public void run()
                {
                    animator.start();
                }
            }).start();
        }
        public void mouseExited(MouseEvent e)
        {
            new Thread(new Runnable()
            {
                @Override
                public void run()
                {
                    if (animator.isAnimating())
                    {
                        animator.stop();
                    }
                }
            }).start();
        }
    }

    private static GLCapabilities createGLCapabilites()
    {
        GLCapabilities capabilities = new GLCapabilities();
        capabilities.setHardwareAccelerated(true);

        // try to enable 2x anti aliasing - should be supported on most hardware
        capabilities.setNumSamples(2);
        //capabilities.setSampleBuffers(true);

        return capabilities;
    }
}
