
package com.locad.viewport;

import java.awt.event.*;

public class Listener implements KeyListener, MouseListener, MouseMotionListener, MouseWheelListener
{
    private final Renderer renderer;
    private final Camera camera;

    public Listener (Renderer renderer, Camera camera)
    {
        this.renderer = renderer;
        this.camera = camera;
    }

    public void keyPressed(KeyEvent e)
    {
        if (e.getKeyCode() == KeyEvent.VK_ESCAPE)
        {
            System.exit(0);     // ESC for exit
        }
    }

    public void keyReleased(KeyEvent e)
    {
    }

    public void keyTyped(KeyEvent e)
    {
    }

    public void mouseEntered(MouseEvent e)
    {
    }

    public void mouseExited(MouseEvent e)
    {
    }

    public void mousePressed(MouseEvent e)
    {
        camera.startDrag(e.getPoint());
        
        // LEFT BUTTON
//        if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) != 0)
//        {
//            renderer.doSelection(e.getPoint(), true);
//        }
    }

    public void mouseReleased(MouseEvent e)
    {
    }

    public void mouseClicked(MouseEvent e)
    {
        // LEFT BUTTON
        if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) != 0)
        {
            renderer.doSelection(e.getPoint(), true);
        }
    }

    public void mouseDragged(MouseEvent e)
    {
        // LEFT BUTTON
        if ((e.getModifiers() & MouseEvent.BUTTON1_MASK) != 0)
        {
            camera.rotate(e.getPoint());
        }

        // MIDDLE BUTTON
        if ((e.getModifiers() & MouseEvent.BUTTON2_MASK) != 0)
        {
            camera.pan(e.getPoint());
        }
    }

    public void mouseWheelMoved (MouseWheelEvent e)
    {
        if (e.getScrollType() == MouseWheelEvent.WHEEL_UNIT_SCROLL)
        {
            camera.zoom(e.getScrollAmount(), e.getWheelRotation());
        }
    }

    // Passive motion callback to capture mouse movements while buttons are not pressed
    public void mouseMoved(MouseEvent e)
    {
    }
}