
package com.locad.geometry;

import com.locad.enumerations.Enumerations.MaterialTypes;
import com.locad.enumerations.Enumerations.ViewAngleModes;
import com.locad.ldraw.ColorLibrary;
import com.locad.ldraw.LDrawColor;
import com.locad.model.Color4b;
import javax.media.opengl.GL;

public class Shape
{
    protected boolean isSelected;
    protected short colorCode = 16;

    public Shape()
    {
    }

    public boolean getIsSelected() { return isSelected; }
    public short getColorCode() { return colorCode; }

    public void setIsSelected(boolean isSelected) { this.isSelected = isSelected; }
    public void setColorCode(short colorCode) { this.colorCode = colorCode; }

    public void addToGL(GL gl, short requestedColorCode, MaterialTypes materialType)
    {
    }

    public void addToGLwithBFC(GL gl, short requestedColorCode, MaterialTypes materialType, boolean BFCflag)
    {
    }
    
    protected Color4b getColor(short requestedColorCode, MaterialTypes materialType)
    {
        LDrawColor ldrawColor = ColorLibrary.getInstance().getColor(colorCode);
        if (colorCode == 16 || colorCode == 24)
            ldrawColor = ColorLibrary.getInstance().getColor(requestedColorCode);

        if (ldrawColor.materialType == materialType)
        {
            if (colorCode == 24)
                return ldrawColor.edgeColor;

            return ldrawColor.fillColor;
        }

        return null;
    }

    public void getBoundingBox(Matrix4f orientation, Point3f minPoint, Point3f maxPoint)
    {
    }

    public boolean contains(Matrix4f orientation, Point3f line, ViewAngleModes viewAngle)
    {
        return false;
    }

    public Shape copy()
    {
        Shape that = new Shape();
        that.colorCode = this.colorCode;
        that.isSelected = this.isSelected;
        return that;
    }

    @Override
    public String toString ()
    {
        StringBuilder strBuffer = new StringBuilder();

        strBuffer.append("colorCode ").append(colorCode).append("\n");
        strBuffer.append("isSelected ").append(isSelected).append("\n");

        return strBuffer.toString();
    }

    public String toString (Matrix4f orientation)
    {
        StringBuilder strBuffer = new StringBuilder();

        strBuffer.append("colorCode ").append(colorCode).append("\n");
        strBuffer.append("isSelected ").append(isSelected).append("\n");

        return strBuffer.toString();
    }
}
