
package com.locad.ldraw;

import com.locad.enumerations.Enumerations.MaterialTypes;
import com.locad.model.Color4b;

public class LDrawColor
{
    public final String name;
    public final Color4b fillColor;
    public final Color4b edgeColor;
    public final Color4b selectedColor;
    public final byte luminance;
    public final MaterialTypes materialType;

    public LDrawColor (String name, Color4b fillColor, Color4b edgeColor, byte luminance, MaterialTypes materialType)
    {
        this.name = name.toUpperCase();
        this.fillColor = fillColor;
        this.edgeColor = edgeColor;
        this.luminance = luminance;
        this.materialType = materialType;

        byte red;
        byte green;
        byte blue;
        if (fillColor.red > 0)
            red = (byte) (fillColor.red - 100);
        else
            red = (byte) (fillColor.red + 100);

        if (fillColor.green > 0)
            green = (byte) (fillColor.green - 100);
        else
            green = (byte) (fillColor.green + 100);

        if (fillColor.blue > 0)
            blue = (byte) (fillColor.blue - 100);
        else
            blue = (byte) (fillColor.blue + 100);


        this.selectedColor = new Color4b(red, green, blue, (byte) 127);
    }

    public LDrawColor copy()
    {
        return new LDrawColor(this.name, this.fillColor, this.edgeColor, this.luminance, this.materialType);
    }

    @Override
    public String toString ()
    {
        StringBuilder strBuffer = new StringBuilder();

        strBuffer.append(" name: ").append(name).append(" fillColor: ").append(fillColor).append(" edgeColor: ").append(edgeColor).append(" selectedColor: ").append(selectedColor).append(" luminance: ").append(luminance);

        return strBuffer.toString();
    }
}