
package com.locad.ldraw;

import com.locad.geometry.Matrix4f;
import com.locad.geometry.Shape;

public class PartEmbeded extends Shape
{
    public final String fileName;
    public final Matrix4f orientation;
    public final boolean BFCflag;

    public PartEmbeded (String fileName, Matrix4f orientation, short colorCode, boolean BFCflag, boolean isSelected)
    {
        this.fileName = fileName;
        this.orientation = orientation;
        this.colorCode = colorCode;
        this.BFCflag = BFCflag;
        this.isSelected = isSelected;
    }

    public static PartEmbeded from_Line (String input, boolean BFCflag)
    {
        String[] tokens = input.trim().split(" ");
        String[] t = new String[tokens.length];
        int ndx = 0;
        for (int i=0; i<tokens.length; i++)
        {
            if (tokens[i] == null ? "" != null : ! tokens[i].equals(""))
            {
                t[ndx] = tokens[i];
                ndx++;
            }
        }

        short colorCode = new Short(t[1]);
        Matrix4f orientation = new Matrix4f(new Float(t[5]),  new Float(t[8]),  new Float(t[11]), 0f,
                                            new Float(t[6]),  new Float(t[9]),  new Float(t[12]), 0f,
                                            new Float(t[7]),  new Float(t[10]), new Float(t[13]), 0f,
                                            new Float(t[2]),  new Float(t[3]),  new Float(t[4]),  1f);

        if (orientation.isInverting())
            BFCflag = !BFCflag;

        String fileName = t[14].replace("\\", "/").toUpperCase();

        return new PartEmbeded(fileName, orientation, colorCode, BFCflag, false);
    }

    @Override
    public PartEmbeded copy()
    {
        return new PartEmbeded(this.fileName, this.orientation, this.colorCode, this.BFCflag, this.isSelected);
    }

    @Override
    public String toString ()
    {
        StringBuilder strBuffer = new StringBuilder();
        strBuffer.append("fileName ").append(fileName).append("\n");
        strBuffer.append(super.toString());
        strBuffer.append("BFCflag ").append(BFCflag).append("\n");
        strBuffer.append("orientation ").append(orientation.toString()).append("\n");
        return strBuffer.toString();
    }
}

