
package com.locad.main;

import com.locad.enumerations.Enumerations.PartCategories;
import java.awt.Color;
import java.util.EnumMap;
import java.util.Map;
import org.apache.log4j.Logger;

public final class Configuration
{
    private final Logger log;

    public final boolean keepLogs = false;

    public final float lineWidth = 2f;
    public final short defaultColorCode = 4;
    public final short defaultPartsBagColorCode = 0;
    public final Color bgColor = Color.WHITE;
    public static final String ldrawDir = "C:/LDraw/";
    public final String partsListFile = ldrawDir + "Parts.lst";
    public final String primitivesListFile = ldrawDir + "Primitives.lst";
    public final String colorFile = ldrawDir + "LDConfig.ldr";
    public final boolean enableLighting = true;
    public final boolean enableBFC = false;

    public final Map<PartCategories, String[]> partFolders = new EnumMap<PartCategories, String[]>(PartCategories.class);

//    public static final String projectFile = ldrawDir + "parts/54872p01.DAT";
    public static final String projectFile = ldrawDir + "parts/2546p01.DAT";
//    public final String projectFile = ldrawDir + "parts/3005pt0.DAT";
//    public final String projectFile = ldrawDir + "parts/3001.DAT";
    //public final String projectFile = ldrawDir + "parts/S/3001s01.DAT";
    //public final String projectFile = ldrawDir + "p/stud.DAT";
    //public final String projectFile = ldrawDir + "p/4-4cyli.DAT";

    private static Configuration instance = null;

    public static Configuration getInstance()
    {
        synchronized (Configuration.class)
        {
            if (instance == null)
            {
                instance = new Configuration();
            }
        }
        return instance;
    }

    private Configuration ()
    {
        log = Logger.getLogger(getClass().getName());

        partFolders.put(PartCategories.PARTS, new String[] { ldrawDir + "PARTS/", "" });
        partFolders.put(PartCategories.SUB_PARTS, new String[] { ldrawDir + "PARTS/", "S/" });
        partFolders.put(PartCategories.PRIMITIVES, new String[] { ldrawDir + "P/", "" });
        partFolders.put(PartCategories.HI_RES_PRIMITIVES, new String[] { ldrawDir + "P/", "48/" });
        partFolders.put(PartCategories.MODELS, new String[] { ldrawDir + "MODELS/", "" });
    }
}
