
package com.locad.model;

import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;
import org.apache.log4j.Logger;

public class Hash
{
    private static Hash instance = null;
    private Logger log;

    protected Hash()
    {
        log = Logger.getLogger(getClass().getName());
    }

    public static Hash getInstance()
    {
        if (instance == null)
        {
            instance = new Hash();
        }

        return instance;
    }

    public String MD5(String msg)
    {
        try
        {
            return toHexString(getDigest("MD5", msg));
        }
        catch (NoSuchAlgorithmException ex)
        {
            log.warn("No Such Algorithm \"MD5\"");
            return "";
        }
    }

    public byte[] MD5_bytes(String msg)
    {
        try
        {
            return getDigest("MD5", msg);
        }
        catch (NoSuchAlgorithmException ex)
        {
            log.warn("No Such Algorithm \"MD5\"");
            return null;
        }
    }

    public String SHA1(String msg)
    {
        try
        {
            return toHexString(getDigest("SHA-1", msg));
        }
        catch (NoSuchAlgorithmException ex)
        {
            log.warn("No Such Algorithm \"SHA-1\"");
            return "";
        }
    }

    public byte[] SHA1_bytes(String msg)
    {
        try
        {
            return getDigest("SHA-1", msg);
        }
        catch (NoSuchAlgorithmException ex)
        {
            log.warn("No Such Algorithm \"SHA-1\"");
            return null;
        }
    }

    public String SHA256(String msg)
    {
        try
        {
            return toHexString(getDigest("SHA-256", msg));
        }
        catch (NoSuchAlgorithmException ex)
        {
            log.warn("No Such Algorithm \"SHA-256\"");
            return "";
        }
    }

    public byte[] SHA256_bytes(String msg)
    {
        try
        {
            return getDigest("SHA-256", msg);
        }
        catch (NoSuchAlgorithmException ex)
        {
            log.warn("No Such Algorithm \"SHA-256\"");
            return null;
        }
    }

    private byte[] getDigest(String algorithm, String msg) throws NoSuchAlgorithmException
    {
        MessageDigest digest = null;

        try
        {
            digest = MessageDigest.getInstance(algorithm);
        }
        catch (NoSuchAlgorithmException ex)
        {
            throw ex;
        }

        String result = "";

        digest.reset();
        digest.update(msg.getBytes());
        byte[] arr = digest.digest();

        return arr;
    }

    private String toHexString(byte[] arr)
    {
        String answer = "";

        int left;
        int right;
        int rightMask = 0x000F;
        int leftMask = 0x00F0;

        for (int i = 0; i < arr.length; ++i)
        {
            right = arr[i] & rightMask;
            left = arr[i] & leftMask;
            left = left >> 4;

            answer += getHexChar(left);
            answer += getHexChar(right);
        }

        return answer;
    }

    private String getHexChar(int var)
    {
        String answer = "";
        switch (var)
        {
            case 1:
                answer += "1";
                break;
            case 2:
                answer += "2";
                break;
            case 3:
                answer += "3";
                break;
            case 4:
                answer += "4";
                break;
            case 5:
                answer += "5";
                break;
            case 6:
                answer += "6";
                break;
            case 7:
                answer += "7";
                break;
            case 8:
                answer += "8";
                break;
            case 9:
                answer += "9";
                break;
            case 10:
                answer += "a";
                break;
            case 11:
                answer += "b";
                break;
            case 12:
                answer += "c";
                break;
            case 13:
                answer += "d";
                break;
            case 14:
                answer += "e";
                break;
            case 15:
                answer += "f";
                break;
            default:
                answer += "0";
                break;
        }
        return answer;
    }
}
