
package com.locad.model;

import java.util.List;

public abstract class ModelListener<E extends ModelObject>
{
    public enum Priority
    {
        HIGH, MEDIUM, LOW
    }

    public abstract void add (E obj);
    public abstract void remove (E obj);
    public abstract void update (E obj);

    public void add (List<E> list)
    {
        for (E e : list)
        {
            add(e);
        }
    }

    public void remove (List<E> list)
    {
        for (E e : list)
        {
            remove(e);
        }
    }

    public void update (List<E> list)
    {
        for (E e : list)
        {
            update(e);
        }
    }
}
